<?

//gzip disabled in announce.php
$disable_gzip = true;

require_once("include/bittorrent.inc.php");
require_once("include/benc.php");
require_once("include/core_func.inc.php");

dbconn();

$user_id = identified_peers_only();

function err($msg) {
	benc_resp(array("failure reason" => array("type" => "string", "value" => $msg)));
	exit();
}

function benc_resp($d) {
	benc_resp_raw(benc(array("type" => "dictionary", "value" => $d)));
}

function benc_resp_raw($x)
{
	header("Content-Type: text/plain");
	header("Pragma: no-cache");
	print($x);
}

$req = "info_hash:peer_id:!ip:port:uploaded:downloaded:left:!event";
foreach (explode(":", $req) as $x) {
	if ($x[0] == "!") {
		$x = substr($x, 1);
		$opt = 1;
	}
	else
		$opt = 0;
	if (!isset($_GET[$x])) {
		if (!$opt)
			err("missing key");
		continue;
	}
	$GLOBALS[$x] = unesc($_GET[$x]);
}

$peer_id = hash_pad($peer_id);

foreach (array("info_hash","peer_id") as $x) {
	if (strlen($GLOBALS[$x]) != 20)
		err("invalid $x (" . strlen($GLOBALS[$x]) . " - " . urlencode($GLOBALS[$x]) . ")");
}

if (empty($ip) || !preg_match('/^(\d{1,3}\.){3}\d{1,3}$/s', $ip))
	$ip = $_SERVER["REMOTE_ADDR"];

$port = intval($port);
$downloaded = intval($downloaded);
$uploaded = intval($uploaded);
$left = intval($left);

$rsize = 50;
foreach(array("num want", "numwant", "num_want") as $k) {
	if (isset($_GET[$k])) {
		$rsize = 0 + $_GET[$k];
		break;
	}
}

if (($port < 1) || ($port > 0xffff))
	err("Invalid port $port");

if (!isset($event))
	$event = "";

$seeder = ($left == 0) ? "yes" : "no";

dbconn(0);

$res = safequery("SELECT id, banned, seeders + leechers AS numpeers FROM torrent WHERE " . hash_where("info_hash", $info_hash));

global $tracker_url;

$torrent = mysql_fetch_assoc($res);
if (!$torrent)
	err("Torrent not registered, see ".$tracker_url."/upload.php");

$torrent_id = $torrent["id"];

$fields = "seeder, peer_id, ip, port";

$numpeers = $torrent["numpeers"];
$limit = "";
if ($numpeers > $rsize)
	$limit = "ORDER BY RAND() LIMIT $rsize";
//$res = safequery("SELECT $fields FROM peer WHERE torrent = $torrent_id AND $limit");
$res = safequery("SELECT $fields FROM peer WHERE torrent = $torrent_id $limit");

$resp = "d" . benc_str("interval") . "i" . $announce_interval . "e" . benc_str("peers") . "l";
unset($self);
while ($row = mysql_fetch_assoc($res)) {
	//$row["peer_id"] = $row["peer_id"];
	
	if (trim($row["peer_id"]) === trim($peer_id)) {
		$self = $row;
		continue;
	}

	$resp .= "d" .
		benc_str("ip") . benc_str($row["ip"]) .
		benc_str("peer id") . benc_str($row["peer_id"]) .
		benc_str("port") . "i" . $row["port"] . "e" .
		"e";
}

$resp .= "ee";

//moved up
//$selfwhere = "torrent = $torrent_id AND (" . hash_where("peer_id", $peer_id) . " OR ip = '$ip')";
//$selfwhere = "(torrent = $torrent_id AND user_id = " . $user_id . ")";
$selfwhere = "(torrent = $torrent_id AND user_id = $user_id)";

if (!isset($self)) {
	$res = safequery("SELECT $fields FROM peer WHERE $selfwhere");
	$row = mysql_fetch_assoc($res);
	if ($row)
		$self = $row;
}

$updateset = array();

if ($event == "stopped")
{
	//peer stopped dl/seed, it must be removed from the database and marked as disconnected
	
	if (isset($self))
	{
		//$peer_was_disconnected = disconnect_peer_temp($torrent_id, $peer_id);
		$peer_was_disconnected = disconnect_peer_temp($selfwhere);
		if ($peer_was_disconnected)	//peer was really disconnected
		{
			if ($self["seeder"] == "yes")
				$updateset[] = "seeders = seeders - 1";
			else if ($self["seeder"] == "no")
				$updateset[] = "leechers = leechers - 1";
			else
				trigger_error("Unknown value for \$self[\"seeder\"] : " . $self["seeder"], E_USER_ERROR);
		}
		else
		{
			trigger_error("Peer id '$peer_id' for torrent id $torrent_idcould not be disconnected", E_USER_ERROR);
			//err("Peer id '$peer_id' could not be disconnected");
		}
		
		//	OLD CODE
		//
		//safequery("DELETE FROM peer WHERE $selfwhere");
		//if (mysql_affected_rows())
		//{
		//	if ($seeder == "yes")
		//		$updateset[] = "seeders = seeders - 1";
		//	else
		//		$updateset[] = "leechers = leechers - 1";
		//}

	}
	else
	{
		trigger_error("Peer could not be disconnected", E_USER_ERROR);
	}
}
else
{
	//another event, peer info is being updated
	
	if ($event == "completed")
	{
		$updateset[] = "times_completed = times_completed + 1";
		safequery("UPDATE user_ratio SET finished_dl_count = finished_dl_count + 1 WHERE user_id = " . $user_id);
	}
	
	if (isset($self))
	{
		//peer is already known (was found from database)
		//the info needs to be updated instead of inserted
		$set =	"user_id = $user_id".
			", peer_id = ". sqlesc($peer_id).	//peer_id needs to be updated as well (this wasn't before)
			", ip = " . sqlesc($ip).
			", port = $port".
			", to_go = $left".
			", last_action = NOW()".
			", seeder = '$seeder'";
		
		//1. client says it has seeded 50MB
		//2. client disconnects and forgets how much it has seeded
		//3. client connects and says it has seeded 0 bytes
		//4. client seeds another 60MB and says it has seeded 60MB, the value will be updated
		//   to 60MB (it should be 50MB + 60MB)

		if (trim($self["peer_id"]) != trim($peer_id))
		{
			//summing values together because the client has forgot it's U/D values
			$set .=	", perm_uploaded = perm_uploaded + temp_uploaded".
				", perm_downloaded = perm_downloaded + temp_downloaded";
		}
		
		//assigning new temp values (peer_id specific)
		$set .=	", temp_uploaded = $uploaded".
			", temp_downloaded = $downloaded";
		
		$res = safequery(
			"UPDATE peer".
			" SET 		$set".
			" WHERE " . $selfwhere
		);
		
		if (connect_peer_temp($selfwhere))
		{
			if ($seeder == "yes")
				$updateset[] = "seeders = seeders + 1";
			else if ($seeder == "no")
				$updateset[] = "leechers = leechers + 1";
			else
				die("hmm");
		}
		else if (mysql_affected_rows() && $self["seeder"] != $seeder)
		{
			if ($seeder == "yes")
			{
				$updateset[] = "seeders = seeders + 1";
				$updateset[] = "leechers = leechers - 1";
			}
			else
			{
				$updateset[] = "seeders = seeders - 1";
				$updateset[] = "leechers = leechers + 1";
			}
		}
	}
	else
	{
		//peer is not known
		//peer information needs to be inserted instead of updating
		
		if (is_connectable($ip, $port))
		{
			$connectable = "yes";
		}
		else
		{
			$connectable = "no";
		}
		
		//$connectable = "unknown";
		
		$ret = safequery(
			"INSERT INTO peer (".
			"user_id".
			", connectable".
			", torrent".
			", peer_id".
			", ip".
			", port".
			", temp_uploaded".
			", temp_downloaded".
			", to_go".
			", started".
			", last_action".
			", seeder".
			", connected".
			") VALUES (".
			$user_id.
			", '$connectable'".
			", $torrent_id".
			", " . sqlesc($peer_id) .
			", " . sqlesc($ip) .
			", $port".
			", $uploaded".
			", $downloaded".
			", $left".
			", NOW()".		//started
			", NOW()".		//last action
			", '$seeder'".		//is seeder?
			", 1".			//connected
			")"
		);
		if ($ret)
		{
			if ($seeder == "yes")
				$updateset[] = "seeders = seeders + 1";
			else
				$updateset[] = "leechers = leechers + 1";
		}
	}
}

if ($seeder == "yes") {
	if ($torrent["banned"] != "yes")
		$updateset[] = "visible = 'yes'";
	$updateset[] = "last_action = NOW()";
}

if (count($updateset) > 0)
{
	//updating torrent information if required
	safequery(
		"UPDATE torrent".
		" SET " . join(",", $updateset) .
		" WHERE id = " . $torrent_id
	);
}

benc_resp_raw($resp);

?>
